using System;
using AspectNet.AOP;
using Rail.Reflect;

namespace AspectNet
{
	/// <summary>
	/// Summary description for Advice.
	/// </summary>
	public class Advice
	{
		private Aspect		_parent		= null;
		private RMethodDef	_methodDef	= null;
		private string		_name		= null;

		public Advice( Aspect parent, RMethodDef method, string name)
		{
			_parent		= parent;
			_methodDef	= method;
			_name		= name;
		}

		public RMethodDef MethodDef
		{
			get { return _methodDef; }
			set { _methodDef = value; }
		}

		/// <summary>
		/// Returns the aspect, containing this advice
		/// </summary>
		public Aspect Aspect
		{
			get
			{
				return _parent;
			}
		}

		public string Name
		{
			get { return _name; }
		}
	}
}
