using System;
using System.Reflection;
using System.Reflection.Emit;
using AspectLib;
using AspectNet.AOP;
using Rail.MSIL;
using Rail.Reflect;
using Rail.Transformation;

namespace AspectNet.Transformations
{
	/// <summary>
	/// Summary description for BaseTransformation.
	/// </summary>
	public class BaseTransformation : ITransformation
	{

		#region ITransformation Members

		/// <summary>
		/// The respective point is being transormed according to
		/// the internal logic of the transformation
		/// </summary>
		public bool TransformJoinPoint( JoinPoint point, Advice advice )
		{
			IJPWeaver jpWeaver = JPFactory.Instance.GetWeaver( point );
			
			jpWeaver.Context = WeaveContext.CreateContext( point, advice, (int)Binding );
			return jpWeaver.TransformJoinPoint();
		}

		/// <summary>
		/// Returns the binding type provided by the transformation
		/// </summary>
		public virtual BindingOpt Binding
		{
			get { throw new NotImplementedException(); }
		}

		#endregion
	}
}
