using System;
using AspectLib;

namespace AspectNet
{
	/// <summary>
	/// Summary description for ITransformation.
	/// </summary>
	public interface ITransformation
	{
		/// <summary>
		/// The respective point is being transormed according to
		/// the internal logic of the transformation
		/// </summary>
		bool TransformJoinPoint(JoinPoint point, Advice advice);
		
		/// <summary>
		/// Returns the binding type provided by the transformation
		/// </summary>
		BindingOpt Binding { get; }
	}
}
