using System.Xml.XPath;

namespace AspectNet
{
	public delegate void AssemblyLoadedHandler(PointCutManager mngr, string asmPath);

	/// <summary>
	/// Summary description for IJPBuilder.
	/// </summary>
	public interface IJPBuilder
	{
		/// <summary>
		/// Returns the token to which this builder corresponds
		/// </summary>
		string XmlTag { get; }
		
		/// <summary>
		/// Loads the assembly and precaches its contents for
		/// faster matching of pointcuts
		/// </summary>
		void PreCacheAssembly(string asmPath);
		
		/// <summary>
		/// Load the builder's configuration data 
		/// from the XML file containing the mapping
		/// </summary>
		void InitializeState(XPathNavigator node);

		/// <summary>
		/// Summary description for IJPBuilder.
		/// </summary>
		void MatchJoinPoints(PointCut pCut);

		/// <summary>
		/// Called to release resources
		/// </summary>
		void Reset();
	}
}
