using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace AspectNetAddIn
{
	/// <summary>
	/// Summary description for SettingsForm.
	/// </summary>
	internal class SettingsForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tboxXSD;
		private System.Windows.Forms.TextBox tboxOutput;
		private System.Windows.Forms.Button btnBrowseXSD;
		private System.Windows.Forms.Button btnBroseOutput;
		private System.Windows.Forms.TextBox tboxMapping;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;


		private Settings _settings;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox tboxAspectLib;
		private System.Windows.Forms.Button btnBrowseAspectLib;
		private System.Windows.Forms.OpenFileDialog openFileDialog2;
		private System.Windows.Forms.CheckBox cboxEnabled;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SettingsForm(Settings settings)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			tboxMapping.Text = settings.XmlMapping;
			tboxOutput.Text = settings.OutputLocation;
			tboxXSD.Text = settings.SchemaLocation;
			tboxAspectLib.Text = settings.AspectLibLocation;
			cboxEnabled.Checked = settings.Enabled;

			_settings = settings;
		}

		public Settings Settings
		{
			get { return _settings; }
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnBrowseAspectLib = new System.Windows.Forms.Button();
			this.tboxAspectLib = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.tboxMapping = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.btnBroseOutput = new System.Windows.Forms.Button();
			this.btnBrowseXSD = new System.Windows.Forms.Button();
			this.tboxOutput = new System.Windows.Forms.TextBox();
			this.tboxXSD = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.folderBrowserDialog1 = new System.Windows.Forms.FolderBrowserDialog();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.openFileDialog2 = new System.Windows.Forms.OpenFileDialog();
			this.cboxEnabled = new System.Windows.Forms.CheckBox();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(336, 184);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 0;
			this.btnOK.Text = "&Ok";
			this.btnOK.Click += new System.EventHandler(this.button1_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(424, 184);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Text = "Ca&ncel";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.btnBrowseAspectLib);
			this.groupBox1.Controls.Add(this.tboxAspectLib);
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.tboxMapping);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.btnBroseOutput);
			this.groupBox1.Controls.Add(this.btnBrowseXSD);
			this.groupBox1.Controls.Add(this.tboxOutput);
			this.groupBox1.Controls.Add(this.tboxXSD);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(488, 160);
			this.groupBox1.TabIndex = 2;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Locations";
			// 
			// btnBrowseAspectLib
			// 
			this.btnBrowseAspectLib.Location = new System.Drawing.Point(416, 88);
			this.btnBrowseAspectLib.Name = "btnBrowseAspectLib";
			this.btnBrowseAspectLib.Size = new System.Drawing.Size(56, 23);
			this.btnBrowseAspectLib.TabIndex = 10;
			this.btnBrowseAspectLib.Text = "Browse";
			this.btnBrowseAspectLib.Click += new System.EventHandler(this.btnBrowseAspectLib_Click);
			// 
			// tboxAspectLib
			// 
			this.tboxAspectLib.Location = new System.Drawing.Point(96, 92);
			this.tboxAspectLib.Name = "tboxAspectLib";
			this.tboxAspectLib.Size = new System.Drawing.Size(312, 20);
			this.tboxAspectLib.TabIndex = 9;
			this.tboxAspectLib.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 92);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(80, 23);
			this.label4.TabIndex = 8;
			this.label4.Text = "AspectLib path";
			// 
			// tboxMapping
			// 
			this.tboxMapping.Location = new System.Drawing.Point(96, 126);
			this.tboxMapping.Name = "tboxMapping";
			this.tboxMapping.ReadOnly = true;
			this.tboxMapping.Size = new System.Drawing.Size(312, 20);
			this.tboxMapping.TabIndex = 7;
			this.tboxMapping.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 126);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 23);
			this.label3.TabIndex = 6;
			this.label3.Text = "XML Mapping";
			// 
			// btnBroseOutput
			// 
			this.btnBroseOutput.Location = new System.Drawing.Point(416, 56);
			this.btnBroseOutput.Name = "btnBroseOutput";
			this.btnBroseOutput.Size = new System.Drawing.Size(56, 24);
			this.btnBroseOutput.TabIndex = 5;
			this.btnBroseOutput.Text = "Browse";
			this.btnBroseOutput.Click += new System.EventHandler(this.btnBroseOutput_Click);
			// 
			// btnBrowseXSD
			// 
			this.btnBrowseXSD.Location = new System.Drawing.Point(416, 24);
			this.btnBrowseXSD.Name = "btnBrowseXSD";
			this.btnBrowseXSD.Size = new System.Drawing.Size(56, 23);
			this.btnBrowseXSD.TabIndex = 4;
			this.btnBrowseXSD.Text = "Browse";
			this.btnBrowseXSD.Click += new System.EventHandler(this.btnBrowseXSD_Click);
			// 
			// tboxOutput
			// 
			this.tboxOutput.Location = new System.Drawing.Point(96, 58);
			this.tboxOutput.Name = "tboxOutput";
			this.tboxOutput.Size = new System.Drawing.Size(312, 20);
			this.tboxOutput.TabIndex = 3;
			this.tboxOutput.Text = "";
			// 
			// tboxXSD
			// 
			this.tboxXSD.Location = new System.Drawing.Point(96, 24);
			this.tboxXSD.Name = "tboxXSD";
			this.tboxXSD.Size = new System.Drawing.Size(312, 20);
			this.tboxXSD.TabIndex = 2;
			this.tboxXSD.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 58);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 23);
			this.label2.TabIndex = 1;
			this.label2.Text = "Output Folder";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(80, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "XSD Location";
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.Filter = "XSD File (*.xsd)|*.xsd";
			this.openFileDialog1.Title = "Select Aspect.Net XSD";
			// 
			// openFileDialog2
			// 
			this.openFileDialog2.Filter = "DLL File (*.dll)|*.dll";
			// 
			// cboxEnabled
			// 
			this.cboxEnabled.Checked = true;
			this.cboxEnabled.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cboxEnabled.Location = new System.Drawing.Point(24, 184);
			this.cboxEnabled.Name = "cboxEnabled";
			this.cboxEnabled.Size = new System.Drawing.Size(272, 24);
			this.cboxEnabled.TabIndex = 11;
			this.cboxEnabled.Text = "Enable Aspect.Net weaving for current solution";
			this.cboxEnabled.CheckedChanged += new System.EventHandler(this.cboxEnabled_CheckedChanged);
			// 
			// SettingsForm
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(506, 223);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.cboxEnabled);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "SettingsForm";
			this.Text = "Aspect.Net Settings";
			this.Load += new System.EventHandler(this.SettingsForm_Load);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			_settings.XmlMapping = tboxMapping.Text;
			_settings.OutputLocation = tboxOutput.Text;
			_settings.SchemaLocation = tboxXSD.Text;
			_settings.AspectLibLocation = tboxAspectLib.Text;
			_settings.Enabled = cboxEnabled.Checked;

			this.Close();
		}

		private void btnBrowseXSD_Click(object sender, System.EventArgs e)
		{
			if ( this.openFileDialog1.ShowDialog() == DialogResult.OK )
			{
				this.tboxXSD.Text = this.openFileDialog1.FileName;
			}
		}

		private void btnBroseOutput_Click(object sender, System.EventArgs e)
		{
			if ( this.folderBrowserDialog1.ShowDialog() == DialogResult.OK )
			{
				this.tboxOutput.Text = this.folderBrowserDialog1.SelectedPath;
			}
		}

		private void btnBrowseAspectLib_Click(object sender, System.EventArgs e)
		{
			if ( this.openFileDialog2.ShowDialog() == DialogResult.OK )
			{
				this.tboxAspectLib.Text = this.openFileDialog2.FileName;
			}
		}

		private void SettingsForm_Load(object sender, System.EventArgs e)
		{
		
		}

		private void cboxEnabled_CheckedChanged(object sender, System.EventArgs e)
		{
			_settings.Enabled = cboxEnabled.Checked;
		}
	}
}
