using System;
using System.Windows.Forms;
using EnvDTE;

namespace AspectNetAddIn.UICommands
{
	/// <summary>
	/// Summary description for TestCommand.
	/// </summary>
	public class TestCommand : BaseCommand
	{
		private const string tstCommandName = "TestCommand1";

		public TestCommand(_DTE application, AspectNetEventSink sink ) : base(application, sink, tstCommandName)
		{
			base.commandText = "Aspect.Net Settings";
			base.commandToolTip = "Test tooltip";
		}

		public override void QueryStatus(string commandName, EnvDTE.vsCommandStatusTextWanted neededText, ref EnvDTE.vsCommandStatus status, ref object commandText)
		{
			status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported | vsCommandStatus.vsCommandStatusEnabled;
			commandText = base.commandText;
		}

		public override void Execute(string commandName, EnvDTE.vsCommandExecOption executeOption, ref object varIn, ref object varOut, ref bool handled)
		{
			handled = eventSink.ShowSettingsDialog();
		}
	}
}
