/*
	The contents of this file are subject to the Mozilla Public License Version 1.1 (the "License"); 
	you may not use this file except in compliance with the License. You may obtain a copy of the License at 
	http://www.mozilla.org/MPL/ 
	Software distributed under the License is distributed on an "AS IS" basis, 
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the specific language 
	governing rights and limitations under the License. 

	The Original Code is RAIL(Runtime Assembly Instrumentation Library) Alpha Version.
	The Initial Developer of the Original Code is University of Coimbra,
	Computer Science Department, Dependable Systems Group. Copyright (C) University of Coimbra. 
	All Rights Reserved.  
*/
using System;
using System.Reflection;

namespace Rail.Reflect 
{
	/// <summary>
	/// 
	/// </summary>
	public abstract class RMember : CustomAttributeOwner
	{
		#region fields
		/// <summary>
		/// 
		/// </summary>
		protected string name;
		/// <summary>
		/// 
		/// </summary>
		protected RType declaringType;
		/// <summary>
		/// 
		/// </summary>
		protected MemberTypes memberType;
		/// <summary>
		/// 
		/// </summary>
		protected BindingFlags bindingFlags;
		#endregion
		
		
		/// <summary>
		/// Gets or sets the name of this member.
		/// </summary>
		public virtual String Name 
		{
			get 
			{
				return this.name;
			}
			set 
			{
				this.name = value;
			}
		}

		/// <summary>
		/// Gets or sets the class that declares this member.
		/// </summary>
		public virtual RType DeclaringType 
		{
			get 
			{
				return this.declaringType;
			}
			set 
			{
				this.declaringType = value;
			}
		}
		/// <summary>
		/// Gets the BindingFlags of the Member
		/// </summary>
		public virtual BindingFlags BindingFlags
		{
			get
			{
				return this.bindingFlags;
			}
			set
			{
				this.bindingFlags = value;
			}
		}

		/// <summary>
		/// Gets the type of this member, such as field, method, and so on.
		/// </summary>
		public virtual MemberTypes MemberType 
		{
			get 
			{
				return this.memberType;
			}
			set
			{
				this.memberType = value;
			}
		}		
	}
}
