/*
	The contents of this file are subject to the Mozilla Public License Version 1.1 (the "License"); 
	you may not use this file except in compliance with the License. You may obtain a copy of the License at 
	http://www.mozilla.org/MPL/ 
	Software distributed under the License is distributed on an "AS IS" basis, 
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the specific language 
	governing rights and limitations under the License. 

	The Original Code is RAIL(Runtime Assembly Instrumentation Library) Alpha Version.
	The Initial Developer of the Original Code is University of Coimbra,
	Computer Science Department, Dependable Systems Group. Copyright (C) University of Coimbra. 
	All Rights Reserved.  
*/
using System;
using System.Collections;
using System.IO;
using System.Reflection;

namespace Rail.Reflect
{
	/// <summary>
	/// Summary description for Resource.
	/// </summary>
	public class RResource
	{
		#region fields

		private string name;
		private byte[] data;
		private ResourceAttributes attributes;
		private string fileName;

		#endregion
		
		/// <summary>
		/// 
		/// </summary>
		public string Name
		{
			get
			{
				return this.name;
			}
			set
			{
				this.name = value;
			}
		}

		/// <summary>
		/// 
		/// </summary>
		public string FileName
		{
			get
			{
				return this.fileName;
			}
			set
			{
				this.fileName = value;
			}
		}


		/// <summary>
		/// 
		/// </summary>
		public byte [] Data
		{
			get
			{
				return this.data;
			}
			set
			{
				this.data = value;
			}
		}

		/// <summary>
		/// 
		/// </summary>
		public ResourceAttributes Attributes
		{
			get
			{
				return this.attributes;
			}
			set
			{
				this.attributes = value;
			}
		}
		
		/// <summary>
		/// 
		/// </summary>
		/// <param name="name"></param>
		/// <param name="data"></param>
		/// <param name="attributes"></param>
		/// <param name="fileName"></param>
		public RResource(string name,byte [] data, ResourceAttributes attributes, string fileName)
		{
			this.name = name;
			this.data = data==null?new byte[0]:data;
			this.attributes = attributes;
			this.fileName = fileName==null?name:fileName;
		}

	}
}
