using System;
using System.Collections;
using AspectLib;

namespace TestAssembly
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	/// 
	[Aspect( Name = "TestAspect" ) ]
	public class Aspect1
	{
		MethodContext t = null;

		[Advice( Name = "MySpecialMethod" )]
		public object MySpecialMethod(object obj)
		{
			System.Console.WriteLine("aspect here");
			int i = (int) ControlFlow.Resume();
			++i;
			System.Console.WriteLine("and aspect there" + i.ToString());

			return i;
		}

		[Advice( Name = "MySpecialMethod2" )]
		public object MySpecialMethod2(object obj)
		{
			System.Console.WriteLine("second aspect here");
			return 1;
		}
	}

	public class Test
	{
		public int TestMethod(string par)
		{
			System.Console.WriteLine("-------->>> real code");

			return 2;
		}

		public void TestMethod2()
		{
			System.Console.WriteLine("-------->>> real code2");
		}
	}

	public class Toster
	{
		public int TestMethod(string par)
		{
			return 1;
		}
	}

/*
	public class MovingUnit{};
	public class Position
	{
		public bool IsValidInMap(GameMap map)
		{
			return true;
		}
	};
	public class GameMap{}

	public class BaseState
	{
		public string ID
		{
			set {}
		}

		public Hashtable StateContainer
		{
			get { return null; }
			set {}
		}
	}

	public class UnitsStateManager
	{
		private UnitsStateManager() {}

		public static UnitsStateManager Instance
		{
			get
			{
				return null;
			}
		}

		public void SaveState( BaseState state ) {}

		public void DeleteState( string id ) {}

	}

	public class Knight : MovingUnit
	{
		private Position	_currentPosition	= new Position();
		private int			_size				= 0;
		private int			_strength			= 0;

		private GameMap		_currentMap			= new GameMap();

		private delegate void NeedRefreshHandler ( object obj );
		
		public event NeedRefreshHandler NeedRefresh; 

		private string ID { get {return ""; } }
		
		private bool Dirty
		{
			get
			{
				return false;
			}
			set
			{
				
			}
		}

		/// <summary>
		/// Changes the position of a Knight object
		/// </summary>
		public void SetPosition( Position newPosition )
		{
			try
			{
				// make sure we are given valid position
				if ( !_currentPosition.IsValidInMap( this._currentMap ) )
				{
					throw new ApplicationException( "InvalidPosition set " +
						this._currentPosition.ToString() );
				}

				// create and initialize the state object
				BaseState currState = new BaseState();

				currState.ID = this.ID;
				Hashtable sc = currState.StateContainer;

				sc.Add( "position", this._currentPosition );
				sc.Add( "size", this._size );
				sc.Add( "strength", this._strength );

				UnitsStateManager.Instance.SaveState( currState );

				// update state
				this._currentPosition = newPosition;

				// raise the event, so that the engine redraws the object
				// in next render cycle
				NeedRefresh( this );
			}
			catch( Exception )
			{
				// in case of exception we should remove the
				// persisted state if we succeeded storing it already
				UnitsStateManager.Instance.DeleteState( this.ID );
				throw;
			}
		}
	}

	[Aspect( Name = "StatePersisterAspect" ) ]
	public class StatePersisterAspect
	{
		/// <summary>
		/// Persists old state of Knight objects
		/// </summary>
		[Advice( Name = "SaveStateKnight" )]
		public object SaveStateKnight(object context)
		{
			Knight unit = 
				((MethodContext)context).ctxObject as Knight;

			// create and initialize the state object
			BaseState currState = new BaseState();

			currState.ID = unit.ID;
			Hashtable sc = currState.StateContainer;

			sc.Add( "position", unit.GetPosition() );
			sc.Add( "size", unit.GetSize() );
			sc.Add( "strength", unit.GetStrength() );

			try
			{
				// perform standard base coding
				ControlFlow.Resume();
				
				// store the old state now
				UnitsStateManager.Instance.SaveState( currState );
			}
			catch
			{
				// remove the eventually stored old state
				UnitsStateManager.Instance.DeleteState( unit.ID );
				// rethrow the error
				throw;
			}

			// we have to return something
			return null;
		}

		/// <summary>
		/// Persists old state of Archer objects
		/// </summary>
		[Advice( Name = "SaveStateArcher" )]
		public object SaveStateArcher(object context)
		{
			...
		}
	}
*/	
}
